require"manage"

module(...,package.seeall)

local smatch,schar = string.match,string.char
local function addparaver()
	nvm.set("paraver",nvm.get("paraver")+1)
end

local function deveventrsp(p,result,user)
	if p.id==protoair.RESET then
		user = {cb=function(result, param)
			if result then sys.restart(param) end
		end, para="SVR RESTART"}
	elseif p.id==protoair.POWEROFF then
		user = {cb=rtos.poweroff}
	end
	linkout.insertOutMsg(linkout.enTopic("deveventrsp/"..(smatch(p.topic,"deveventreq/(.+)") or "")),
						protoair.pack(protoair.DEVEVENTRSP,p.id,schar(result or 1)),
						1,user)
end

local function setpara(p)	
	local procer,result = {
		[protoair.RPTFREQ] = "rptfreq",
	}
	if procer[p.cmd] then
		local typ = type(procer[p.cmd])
		if typ == "function" then
			result = procer[p.cmd](p)
		elseif typ == "table" then
			if type(procer[p.cmd].k) == "function" then
				result = procer[p.cmd].k(p,procer[p.cmd].v)
			else
				result = nvm.set(procer[p.cmd].k,procer[p.cmd].v,"SVR")
			end
		else
			addparaver()
			result = nvm.set(procer[p.cmd],p.val,"SVR")
		end
	end
	linkout.insertOutMsg(linkout.enTopic("devpararsp/"..(smatch(p.topic,"devparareq/(.+)") or "")),
						protoair.pack(protoair.SETPARARSP,p.cmd,schar(result and 1 or 0)),
						1)
end

local function qryloc(p)
	deveventrsp(p)
	linkout.locReport(protoair.QRYPOS)
end

local function restore(p)
	sys.publish("SVR_RESTORE_IND","SVR")
	deveventrsp(p)
end

local setclked
local function datetime(p)
	--print("Server datetime p",p.year,p.month,p.day,p.hour,p.min,p.sec)
	if not setclked then
		misc.setClock(p)
		setclked = true
	end
end

local function smpset(p)	
		local procer = {
		[protoair.DATETIME] = datetime,
	}
		
	if procer[p.cmd] then
		local typ = type(procer[p.cmd])
		if typ == "function" then
			procer[p.cmd](p)
		end		
	end
end


local function qrypara(p)
	local procer,rsp = {
		[protoair.VER] = function() return _G.PROJECT.."_".._G.VERSION end,
		[protoair.DEVPARA] = function() sys.publish("DEVPARA_RPT_REQ") return schar(1) end,
	}
	if procer[p.val] then
		rsp = procer[p.val]()
	end
	if rsp then
		linkout.insertOutMsg(linkout.enTopic("deveventrsp/"..(smatch(p.topic,"deveventreq/(.+)"))),
						protoair.pack(protoair.DEVEVENTRSP,p.id,schar(p.val)..rsp),
						1)
	end
end

local cmds = {
	[protoair.SETPARA] = setpara,
	[protoair.QRYLOC] = qryloc,
	[protoair.RESET] = deveventrsp,
	[protoair.POWEROFF] = deveventrsp,
	[protoair.RESTORE] = restore,
	[protoair.SMPSET] = smpset,
	[protoair.QRYPARA] = qrypara,
}

function procMsg(mqttc)
	local r,data
	while true do
		r,data = mqttc:receive(2000)
		
		if r and data~="timeout" then
			log.info("linkin.procMsg",data.topic,string.toHex(data.payload))
			local packet = protoair.unpack(data.payload)
			if packet and packet.id and cmds[packet.id] then
				packet.topic = data.topic
				cmds[packet.id](packet)
				if linkout.waitForSend() then return true end
			end
		else
			break
		end
	end
	
	return data=="timeout" or r
end
